---
title: 'get Array[@@species]'
slug: Web/JavaScript/Reference/Global_Objects/Array/@@species
tags:
  - Array
  - JavaScript
  - Method
  - Prototype
---
<div>{{JSRef}}</div>

<p>The <strong><code>Array[@@species]</code></strong> accessor property returns the <code>Array</code> constructor.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Array[Symbol.species]
</pre>

<h3 id="Return_value">Return value</h3>

<p>The {{jsxref("Array")}} constructor.</p>

<h2 id="Description">Description</h2>

<p>The <code>species</code> accessor property returns the default constructor for <code>Array</code> objects. Subclass constructors may override it to change the constructor assignment.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Species_in_ordinary_objects">Species in ordinary objects</h3>

<p>The <code>species</code> property returns the default constructor function, which is the <code>Array</code> constructor for <code>Array</code> objects:</p>

<pre class="brush: js notranslate">Array[Symbol.species]; // function Array()</pre>

<h3 id="Species_in_derived_objects">Species in derived objects</h3>

<p>In a derived collection object (e.g. your custom array <code>MyArray</code>), the <code>MyArray</code> species is the <code>MyArray</code> constructor. However, you might want to overwrite this, in order to return parent <code>Array</code> objects in your derived class methods:</p>

<pre class="brush: js notranslate">class MyArray extends Array {
  // Overwrite MyArray species to the parent Array constructor
  static get [Symbol.species]() { return Array; }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-get-array-@@species', 'get Array [ @@species ]')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.@@species")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array")}}</li>
 <li>{{jsxref("Symbol.species")}}</li>
</ul>
